<#ibiztemplate>
TARGET=PSDEDBTABLE
</#ibiztemplate>
<#if  de.getAllPSDEDataSets()??>
<#assign resultSet=de.getAllPSDEDataSets()>
</#if>
<#if  de.getAllPSDEDataQueries()??>
<#assign dataQueries=de.getAllPSDEDataQueries()>
</#if>
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper	namespace="${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().codeName?lower_case}.mapper.${item.name}Mapper">

    <update id="updateById" parameterType="${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().codeName?lower_case}.po.${item.name}Impl">
        update ${item.name} t
        <trim prefix="set" suffixOverrides=",">
		<#list de.getAllPSDEFields()  as defield>
			<#if defield.getPSSysDBColumn()??>
		<if test="true == et.${defield.codeName?uncap_first}DirtyFlag"> ${defield.name?lower_case} = <#noparse>#{</#noparse>et.${defield.codeName?uncap_first}<#noparse>},</#noparse> </if>
			</#if>
		</#list>
        </trim>
        where t.${de.getKeyPSDEField().name?lower_case} = <#noparse>#{</#noparse>et.${de.getKeyPSDEField().codeName?uncap_first}<#noparse>}</#noparse>
    </update>

	<!--该方法用于重写mybatis中selectById方法，以实现查询逻辑属性-->
	<#comment>无视图模式-查询view的数据查询</#comment>
	<#if de.isNoViewMode()==true>
		<#list dataQueries as singleQuery>
			<#if singleQuery.getCodeName()?lower_case=='view'>
				<#if singleQuery.getAllPSDEDataQueryCodes()??>
					<#assign queryCodeList = singleQuery.getAllPSDEDataQueryCodes()>
					<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
						<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectById"  resultMap="${item.name}ResultMap" databaseId="${dbtype}">
		<![CDATA[	select t1.* from (
		${contextParamConvert(srfjavasqlcode(dedqcode.getQueryCode()))}
		)t1     where  ${de.getKeyPSDEField().name?lower_case}=<#noparse>#{id}</#noparse>]]>
	</select>
					</#list>
				</#if>
				<#break>
			</#if>
		</#list>
	<#else>
		<#comment>直接查询视图</#comment>
		<#list dataQueries as singleQuery>
			<#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
				<#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
	<select id="selectById"  resultMap="${item.name}ResultMap" databaseId="${dbtype}">
		<![CDATA[	select t1.* from (
		select * from ${de.getViewName()?lower_case}
		)t1     where  ${de.getKeyPSDEField().name?lower_case}=<#noparse>#{id}</#noparse>]]>
	</select>
			</#list>
		<#break>
		</#list>
	</#if>

	<!--通过mybatis将查询结果注入到entity中,通过配置autoMapping="true"由mybatis自动处理映射关系 -->
	<resultMap id="${item.name}ResultMap" type="${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().codeName?lower_case}.po.${item.name}Impl" autoMapping="true">
		<id property="${de.getKeyPSDEField().codeName?uncap_first}" column="${de.getKeyPSDEField().getName()?lower_case}" /><!--主键字段映射-->
		<#comment>外键值字段映射：由于需要将一个数据库列注入到2个domian属性中(主关系实体对象)，由于已经手动将列映射给主关系对象，所以autoMapping将不会自动注入外键id，需要再次声明映射关系</#comment>
		<#--<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>-->
			<#--<#list de.getMinorPSDERs() as MinorPSDER>-->
				<#--<#if MinorPSDER??  && MinorPSDER.getDERType()=='DER1N'>-->
					<#--<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>-->
						<#--<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>-->
						<#--<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >-->
							<#--<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>-->
								<#--<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>-->
								<#--<#assign MajorField = MinorPSDER.getPSPickupDEField()>-->
		<#--<result property="${MajorField.codeName?lower_case}" column="${MajorField.getName()?lower_case}" /><!--关系字段映射&ndash;&gt;-->
							<#--</#if>-->
						<#--</#if>-->
					<#--</#if>-->
				<#--</#if>-->
			<#--</#list>-->
		<#--</#if>-->
		<#--<#comment>1：N关系中，在子实体中创建父实体的实例对象</#comment>-->
		<#--<#if de.getMinorPSDERs?? && de.getMinorPSDERs()??>-->
		<#--<#list de.getMinorPSDERs() as MinorPSDER>-->
		<#--<#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>-->
		<#--<#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()??>-->
			<#--<#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>-->
			<#--<#if MajorEntity.name?? && MinorPSDER.getCodeName()?? >-->
			<#--<#if MinorPSDER.getPSPickupDEField?? && MinorPSDER.getPSPickupDEField()??>-->
			<#--<#assign MajorkeyField = MajorEntity.getKeyPSDEField()>-->
			<#--<#assign MajorField = MinorPSDER.getPSPickupDEField()>-->
		<#--<!--通过mybatis自动注入关系属性[主实体]，fetchType="lazy"为懒加载配置 &ndash;&gt;-->
		<#--<association property="${MinorPSDER.getCodeName()?lower_case}" javaType="${pub.getPKGCodeName()}.${MajorEntity.getPSSystemModule().codeName?lower_case}.domain.${MajorEntity.codeName}" column="${MajorField.getName()?lower_case}" select="${pub.getPKGCodeName()}.${MajorEntity.getPSSystemModule().codeName?lower_case}.mapper.${MajorEntity.codeName}Mapper.selectById" fetchType="lazy"></association>-->
			<#--</#if>-->
			<#--</#if>-->
		<#--</#if>-->
		<#--</#if>-->
		<#--</#list>-->
		<#--</#if>-->
		<#--<#comment>1：N关系中，在父实体中创建子实体的List集合</#comment>-->
		<#--<#if de.getMajorPSDERs?? && de.getMajorPSDERs()??>-->
		<#--<#list de.getMajorPSDERs() as MajorPSDER>-->
		<#--<#if MajorPSDER??>-->
		<#--<#if MajorPSDER.getMinorPSDataEntity?? && MajorPSDER.getMinorPSDataEntity()?? && MajorPSDER.getMinorCodeName?? && MajorPSDER.getMinorCodeName()?? && MajorPSDER.getDERType()=='DER1N'>-->
			<#--<#assign MinorEntity = MajorPSDER.getMinorPSDataEntity()>-->
			<#--<#assign MajorDerField = MajorPSDER.getPSPickupDEField()>-->
			<#--<#if MinorEntity.name?? && MajorPSDER.getCodeName()?? && MajorPSDER.getMinorCodeName()!=''>-->
		<#--<!--通过mybatis自动注入关系属性[关系实体]，fetchType="lazy"为懒加载配置 &ndash;&gt;-->
		<#--<collection property="${MajorPSDER.getMinorCodeName()?lower_case}" ofType="${pub.getPKGCodeName()}.${MinorEntity.getPSSystemModule().codeName?lower_case}.domain.${MinorEntity.codeName}" column="${de.getKeyPSDEField().getName()?lower_case}" select="${pub.getPKGCodeName()}.${MinorEntity.getPSSystemModule().codeName?lower_case}.mapper.${MinorEntity.codeName}Mapper.selectBy${MajorDerField.getName()?lower_case}" fetchType="lazy"></collection>-->
			<#--</#if>-->
		<#--</#if>-->
		<#--</#if>-->
		<#--</#list>-->
		<#--</#if> -->
	</resultMap>

	<#comment>暂未实现多数据源，暂时先发布单数据库</#comment>
	<#if resultSet??>
	<#list resultSet as  singleSet>
	<#if singleSet.getPSDEDataQueries()??>
    <!--数据集合[${singleSet.getCodeName()}]-->
	 <select id="search${singleSet.getCodeName()}"  parameterType="${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.filter.${de.codeName}SearchContext"  resultMap="${item.name}ResultMap">
         select t1.* from (
             <foreach item="item" collection="srf.dataQueryList" separator="union all" index="index">
                 <bind name="dataQueryId" value="item" />
                 <include refid="dataQuerySql" />
             </foreach>
         )t1
         <where><if test="ew!=null and ew.sqlSegment!=null and !ew.emptyOfWhere"><#noparse>${ew.sqlSegment}</#noparse></if></where>
         <if test="ew!=null and ew.sqlSegment!=null and ew.emptyOfWhere"><#noparse>${ew.sqlSegment}</#noparse></if>
     </select>

	</#if>
	</#list>
	</#if>
    <#comment>数据查询</#comment>
    <#if  de.getAllPSDEDataQueries()??>
        <#list de.getAllPSDEDataQueries() as singleQuery>
            <#if singleQuery.getAllPSDEDataQueryCodes()??>
                <#list singleQuery.getAllPSDEDataQueryCodes() as dedqcode>
                    <#assign dbtype=dedqcode.getDBType()?lower_case?replace("mysql5","mysql")>
    <!--数据查询[${singleQuery.getCodeName()}]-->
    <sql id="${singleQuery.getCodeName()}" databaseId="${dbtype}">
        select t1.* from (
        <![CDATA[	${contextParamConvert(srfjavasqlcode(dedqcode.getQueryCode()))}  ]]>
            <#if dedqcode.getPSDEDataQueryCodeConds()??>
      <![CDATA[	<#list dedqcode.getPSDEDataQueryCodeConds() as dedqfieldcond>
                <#if (dedqfieldcond_index==0)> WHERE </#if>	<#if (dedqfieldcond_index>0)> AND 	</#if>
                ${contextParamConvert(srfjavasqlcode(dedqfieldcond.getCustomCond()))}
            </#list>
          ]]>
            </#if>
        )t1
    </sql>

                </#list>
            </#if>
        </#list>
    </#if>
    <#comment>数据查询选择</#comment>
    <#if  de.getAllPSDEDataQueries()??>
    <!--数据查询选择-->
    <sql id="dataQuerySql">
        <choose>
        <#list de.getAllPSDEDataQueries() as singleQuery>
            <when test="dataQueryId=='${singleQuery.codeName}'">
                <include refid="${singleQuery.codeName}"/>
            </when>
        </#list>
        </choose>
    </sql>

    </#if>
</mapper>

<#comment>上下文参数转换</#comment>
<#function contextParamConvert contextParam>
	<#assign resultParam="">
	<#assign resultParam=contextParam?replace('$\{srfdatacontext(\'','#\{srf.datacontext.')?replace("','\\{[\\S]*","\\}","r")><#comment>数据上下文</#comment>
	<#assign resultParam=resultParam?replace('$\{srfsessioncontext(\'','#\{srf.sessioncontext.')?replace("','\\{[\\S]*","\\}","r")><#comment>用户上下文</#comment>
	<#assign resultParam=resultParam?replace('$\{srfwebcontext(\'','#\{srf.webcontext.')?replace("','\\{[\\S]*","\\}","r")><#comment>网页请求上下文</#comment>
	<#return resultParam>
</#function>
